package com.inforbooks.tests;

import android.app.Activity;
import android.os.Bundle;
import android.os.Environment;
import android.util.Log;
import android.view.View;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;

import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;


public class ArchivoExternoActivity extends Activity {
    
	// variables/objetos que se usan en toda la clase
	private EditText editText;
	// tamao del bufer de lectura
	private static final int BUFFER_BYTES = 80;
	
    /** OnCreate: se llama al crearse el objeto. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);      
        
        Button btnGuardar = (Button) findViewById(R.id.btnGuardar);
        Button btnLeer = (Button) findViewById(R.id.btnLeer);   
        
        // se obtiene el control EditText
        // (objeto hijo de TextView pero editable)
        editText = (EditText) findViewById(R.id.editText1);
     
        
        // Un clic en el botn Leer
        // provoca que se lea  
        // el archivo
        btnLeer.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                try 
                {   
                	if (checkAlmacenamientoExterno()){
                	// acceso al almacenamiento externo del dispositivo
                	File objSD = Environment.getExternalStorageDirectory();
                	File objCarpeta = new File(objSD.getAbsolutePath() +
                			"/MisDocs");
                	File objFile = new File(objCarpeta, "file01.txt");                	
                    FileInputStream objOfi = new FileInputStream(objFile);                   
                    // fin de la parte diferente respecto al proyecto
                    // ArchivoLeerGrabar en la lectura del archivo
                    
                    InputStreamReader objIsr = new InputStreamReader(objOfi);
                  
                    // se crea un bufer de entrada
                    char[] inBuf = new char[BUFFER_BYTES];
                    String str = "";
     
                    // lee el primer bloque
                    // en cLeidos queda el valor de caracteres 
                    // ledos
                    int cLeidos = objIsr.read(inBuf);
                    
                    // lectura bloque a bloque
                    // mientra la cantidad de caracteres ledos
                    // sea mayor a cero
                    while (cLeidos > 0)
                    {                    
                        // copyValueOf: conversin del flujo 
                    	// de caracteres a cadena
                                       	
                    	// atencin: la lectura puede ser menor que 
                    	// la longitud del bufer (es lo normal en 
                    	// la ltima lectura), por eso se usa
                    	// cLeidos y no BUFFER_BYTES
                        str += String.copyValueOf(inBuf, 0, cLeidos);                
                        
                        // se crea el nuevo bufer de entrada
                        inBuf = new char[BUFFER_BYTES];
                       
                        // nueva lectura
                        cLeidos = objIsr.read(inBuf);                       
                    } 
                    // asigna toda la cadena leda
                    // al control editable                                
                     editText.setText(str);
                     
                    // mensaje de lectura correcta
                    Toast.makeText(getBaseContext(),"Lectura correcta del archivo", Toast.LENGTH_SHORT).show();
                    objIsr.close();
                	}
                } 
                catch (IOException e) { 
               	    // generar un mensaje de excepcin
       			    Log.e("test", "excepcin al procesar archivo en lectura", e);                     
                }            	
            }
        });
    
   
        // Un clic en el botn Guardar
        // provoca que el contenido se escribe en 
        // el archivo
        btnGuardar.setOnClickListener(new View.OnClickListener() {
        public void onClick(View v) {         
        	
        	// se obtiene la cadena de texto
        	// que se han introducido en el
        	// control EditText
        	String str = editText.getText().toString();
            try 
            {   
            	
            	if (checkAlmacenamientoExterno()){
            	// inicio de la parte diferente (2) respecto al proyecto
                // ArchivoLeerGrabar
            	// acceso al almacenamiento externo del dispositivo
            	File objSD = Environment.getExternalStorageDirectory();
            	File objCarpeta = new File(objSD.getAbsolutePath() +
            			"/MisDocs");
            	objCarpeta.mkdirs();
            	File objFile = new File(objCarpeta, "file01.txt");                	
                FileOutputStream objFos = new FileOutputStream(objFile);               
                // fin de la parte diferente (2) respecto al proyecto
                // ArchivoLeerGrabar   
                
                // se crea un objeto OutputStreamWriter
                // que nos permite escribir
                OutputStreamWriter objOsw = new  OutputStreamWriter(objFos);
                
                // escribe la cadena en el archivo
                objOsw.write(str);              
                objOsw.flush(); 
                objOsw.close();
                
                // escritura correcta
                Toast.makeText(getBaseContext(), "Escritura correcta", Toast.LENGTH_SHORT).show();
             
                // limpia el contenido del control
               editText.setText("");
            	}
             
             } 
             catch (IOException e) 
             { 
            	 // generar un mensaje de excepcin
    			 Log.e("test", "excepcin al procesar archivo en escritura", e);                     
             }  
             //==================================
        }
    });
    
}
    public boolean checkAlmacenamientoExterno() {
    	
    	boolean puedoLeer = false; 
    	boolean puedoEscribir = false;
    	String state = Environment.getExternalStorageState();
    	
    	if (Environment.MEDIA_MOUNTED.equals(state)){
    		puedoLeer = true;
    		puedoEscribir = true;
    	} else if (Environment.MEDIA_MOUNTED_READ_ONLY.equals(state)) {
    		puedoLeer= true;
    	}
    	
    	return puedoLeer && puedoEscribir;
    	
    }
}