package com.inforbooks.testbasedatos;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

import android.database.Cursor;


public class ArchivoBaseDatosActivity extends Activity {   
	
	private AdaptadorBD miBD;
	private AdaptadorBD miBD2;
	// cursor de uso general
	private Cursor generalCursor;
	
	// cursor auxiliar para 
	// actualizar/eliminar
	private Cursor updateCursor;
	 
	private boolean bCurActivo = false;
	
	// datos de la fila vigente
	private Integer _id;
	private String 	_nombre;
	private Integer _nroemp;
	private Float 	_salario;
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);    
       
        try {        	
        	String carpetaDest = "/data/data/" + getPackageName() + "/databases/empresa";
        	File f = new File(carpetaDest);        	
        	if (!f.exists()) {        	
        		copiarBD( getBaseContext().getAssets().open("empresa"), 
        		new FileOutputStream(carpetaDest));
        	}
        } catch (FileNotFoundException e) {			
        	e.printStackTrace();
        } catch (IOException e) {
        	e.printStackTrace();
        }
       
        // crea el objeto base de datos
       miBD = new AdaptadorBD(this); 
       miBD2 = new AdaptadorBD(this);
      
    }
    
	///////////////////////////////////
	// gestionar el clic de los botones
	///////////////////////////////////
    
    // Mtodo para insertar una fila nueva
	public void onClickInsertar(View v) {
        	// aadimos una fila
		 	String msg;
            
            if (readInterfaz()<1){
            	msg ="No hay nro. de empleado";
            	Toast.makeText(this,  msg, Toast.LENGTH_LONG).show();
            	return;
            }
            
            miBD.open(); 
            long id = miBD.insertarFila(_nombre, _nroemp, _salario);           
           
            if (id != -1) { 
            	msg = "Fila insertada con clave " + String.valueOf(id);
            	limpiarInterfaz();} 
            else msg ="No se insert ninguna fila";
            Toast.makeText(this,  msg, Toast.LENGTH_LONG).show();
              
            miBD.close();
            // los botones de edicin se desactivan
            botonesEdicion(false);
	} 
	
    // Mtodo para listar todos los registros     
	public void onClickListarTodos(View v) {        
        	// obtener la lista de todas las filas
        	miBD.open();
        	// carga el cursor con todas las filas
        	generalCursor = miBD.leerTodos();
        	// recorre el cursor
        	if (generalCursor.moveToFirst()) {
        		do { mostrarFila(generalCursor);} while (generalCursor.moveToNext());
        	}
        	Toast.makeText(this, "No hay ms filas para mostrar", Toast.LENGTH_LONG).show();
        	// Cierra el cursor
        	generalCursor.close();
        	// cierra la base de datos
        	miBD.close();
	}    
	
	// Mtodo para buscar por nombre
	public void onClickBuscar(View v) {
		
		// obtiene el nombre que se quiere buscar
        EditText objEt1 = (EditText) findViewById(R.id.EditText_Nombre);
        _nombre =  objEt1.getText().toString();
        
    	// obtener las filas con ese nombre
        // puede haber 0, 1 o + de 1
        // ya que no es un campo identificador nico
        
        // obtiene un cursor 
     	// para editar fila a fila
     	if (!bCurActivo) {
     		miBD2.open();
     		// obtiene la lista completa de filas
     		updateCursor = miBD2.leerPorNombre(_nombre);
     		bCurActivo = true;
     		
     		// posiciona en la primera fila 
     		if (updateCursor.moveToFirst())  {
     			// coloca los datos en los cuadros de edicin
     			putInterfaz(updateCursor);
     		}
     		else {
     			// la tabla no tiene ninguna fila
     			Toast.makeText(this, "No hay ninguna fila", Toast.LENGTH_LONG).show(); 
     			updateCursor.close();
     			miBD2.close();
     			bCurActivo = false;
     		} 
     	} else {
     		// nos movemos por el cursor
     		if (updateCursor.moveToNext()) { 
     			// coloca los datos en los cuadros de edicin
     			putInterfaz(updateCursor);
     		} else {
     			// fin de filas
     			updateCursor.close();
     			miBD2.close();
     			bCurActivo = false;
     			Toast.makeText(this, "Ya no hay ms filas", Toast.LENGTH_LONG).show();
     			botonesEdicion(false);
     		}	
	   }
	}        
        
	// Mtodo para listar con edicin permitida
	public void onClickListarParaEditar(View v) {
	
		// obtiene un cursor 
		// para editar fila a fila
		if (!bCurActivo) {
			miBD2.open();
			// obtiene la lista completa de filas
			updateCursor = miBD2.leerTodos();
			bCurActivo = true;
			
			// posiciona en la primera fila 
			if (updateCursor.moveToFirst())  {
				// coloca los datos en los cuadros de edicin
				putInterfaz(updateCursor);
			}
			else {
				// la tabla no tiene ninguna fila
				Toast.makeText(this, "No hay ninguna fila", Toast.LENGTH_LONG).show(); 
				updateCursor.close();
				miBD2.close();
				bCurActivo = false;
			} 
		} else {
			// nos movemos por el cursor
			if (updateCursor.moveToNext()) { 
				// coloca los datos en los cuadros de edicin
				putInterfaz(updateCursor);
			} else {
				// fin de filas
				updateCursor.close();
				miBD2.close();
				bCurActivo = false;
				Toast.makeText(this, "Ya no hay ms filas", Toast.LENGTH_LONG).show();
				botonesEdicion(false);
			}	
		}
		  
	}
	     
	// Mtodo para actualizar la fila vigente
	public void onClickActualizar(View v) {   
		// actualiza una fila por nmero de identificador
		miBD.open();
		
		// lee los datos desde los cuadros de edicin 
		// se verifica que el nro. de empleado sea diferente de 0
		if (readInterfaz()<1){
			Toast.makeText(this,  "No hay empleado", Toast.LENGTH_LONG).show();
			return;
		}
        	
		if (miBD.actualizarFila(_id, _nombre, _nroemp, _salario)>0)
			Toast.makeText(this, "actualizado", Toast.LENGTH_LONG).show();
		else Toast.makeText(this, "no pudo actualizar", Toast.LENGTH_LONG).show();        
		miBD.close();
	}
      
	// Mtodo para eliminar el empleado vigente
	public void onClickEliminar(View v) {   
		// eliminar una fila por nmero de identificador
		miBD.open();
		
		// el identificador es nico, por lo tanto
		// es el campo adecuado para buscar y eliminar
		if (miBD.eliminarFila(_id)){
			Toast.makeText(this, "eliminado", Toast.LENGTH_LONG).show();
			limpiarInterfaz();
		}
		else  Toast.makeText(this, "no pudo eliminar", Toast.LENGTH_LONG).show();            
		miBD.close();
	} 
	
	// Mtodo para limpiar toda la tabla!!!!
	public void onClickEliminarTodos(View v) {   
    	// eliminar todas las filas
    	miBD.open();
    	if (miBD.eliminarTodo())
    		Toast.makeText(this, "eliminado todo", Toast.LENGTH_LONG).show();
    	else  Toast.makeText(this, "no pudo eliminar", Toast.LENGTH_LONG).show();            
    	miBD.close();
    	limpiarInterfaz();
	}
	
	// Limpia la interfaz
	public void onClickClear(View v) {   
		// clic en botn Clear
		// para limpiar las reas de edicin
		limpiarInterfaz();
    	
	} 
	
	// Mtodo auxiliar ya que se usa desde 
	// varios puntos del programa
	public void limpiarInterfaz(){
		// limpia los datos de la interfaz		
        EditText objEt1 = (EditText) findViewById(R.id.EditText_Nombre);
        objEt1.setText("");
        
        EditText objEt2 = (EditText) findViewById(R.id.EditText_Nroemp);
        objEt2.setText("");
        
        EditText objEt3 = (EditText) findViewById(R.id.EditText_Salario);
        objEt3.setText("");
        
        botonesEdicion(false);		
	}
	
	// Lectura de los controles de la interfaz  
	public int readInterfaz(){
		// obtiene datos desde de los cuadros de texto
        EditText objEt1 = (EditText) findViewById(R.id.EditText_Nombre);
        _nombre =  objEt1.getText().toString();
        
        EditText objEt2 = (EditText) findViewById(R.id.EditText_Nroemp);
        String strNroemp = objEt2.getText().toString();        
        _nroemp = Integer.valueOf(strNroemp);
        
        EditText objEt3 = (EditText) findViewById(R.id.EditText_Salario);
        String strSalario = objEt3.getText().toString();        
        _salario = Float.valueOf(strSalario);
        
        // evitamos que haya empleados con nro 0
        // en la tabla
        return _nroemp;		
	}
	
	// Mtodo para pasar los datos desde el cursor 
	// a la interfaz
	public void putInterfaz(Cursor c)	 {			
		 // coloca datos de los cuadros de texto
        EditText objEt1 = (EditText) findViewById(R.id.EditText_Nombre);
        objEt1.setText(c.getString(1));
        
        EditText objEt2 = (EditText) findViewById(R.id.EditText_Nroemp);
        objEt2.setText(c.getString(2)); 
        
        EditText objEt3 = (EditText) findViewById(R.id.EditText_Salario);
        objEt3.setText(c.getString(3));
        
        // coloca los datos de la fila
        // en variables  
        _id = Integer.valueOf(c.getString(0));
        _nombre = c.getString(1);
        _nroemp = Integer.valueOf(c.getString(2));
        _salario = Float.valueOf(c.getString(3));
        // cuando hay datos en la interfaz se 
        // hace que los botones de edicin sean clicables
        botonesEdicion(true);
        
	} 
	
	// Activacin y descativacin de botones
	public void botonesEdicion(boolean b){
		// activa o desactiva los botones
		// de actualizar o eliminar
		// segn haya o no una fila mostrada
		// en la zona de edicin
		 Button objB1 = (Button) findViewById(R.id.button4);
	     objB1.setClickable(b);
	     
	     Button objB2 = (Button) findViewById(R.id.button5);
	     objB2.setClickable(b);
	}
         
	// Mtodo auxiliar para copiar el esquema de la base de datos
	// en cada recreacin
    public void copiarBD(InputStream inputStream, OutputStream outputStream) 
            throws IOException {
    	// copia de a 1024 bytes
    	byte[] buffer = new byte[1024];
    	int length;
    	while ((length = inputStream.read(buffer)) > 0) {
    		outputStream.write(buffer, 0, length);
    	}
    	inputStream.close();
    	outputStream.close();
	}
           
    // Muestra los datos del empleado vigente
	public void mostrarFila(Cursor c)	 {
		Toast.makeText(this, 
				"id: " + c.getString(0) + "\n" +
                 "Nombre: " + c.getString(1) + "\n" +
                 "Nro.emp.: " + c.getString(2) + "\n" +
                 "Salario:  " + c.getString(3),
                 Toast.LENGTH_LONG).show();        
	} 
}