package com.inforbooks.tests;

import android.app.Activity;
import android.os.Bundle;
import android.os.Environment;
import android.util.Log;
import android.view.View;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;

import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;


public class ArchivoRecursoActivity extends Activity {
    
	// variables/objetos que se usan en toda la clase
	private EditText editText;
	
    /** OnCreate: se llama al crearse el objeto. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);      
        
        Button btnGuardar = (Button) findViewById(R.id.btnGuardar);
        Button btnLeer = (Button) findViewById(R.id.btnLeer);   
        
        // se obtiene el control EditText
        // (objeto hijo de TextView pero editable)
        editText = (EditText) findViewById(R.id.editText1);
     
        
        // Un clic en el botn Leer
        // provoca que se lea el archivo 
        // de la carpeta de recursos raw
        btnLeer.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {               
            	String buf = ""; 
                String str = null;
                	
                try {
                	InputStream objIS = ArchivoRecursoActivity.this.getResources().openRawResource(R.raw.archivo);
                    	
                	BufferedReader objBR = new BufferedReader(new InputStreamReader(objIS));
                    	
                    	
                	while ((str = objBR.readLine()) != null ){
        					buf += str;
                	}
                	objIS.close();
                	objBR.close();
                } catch (IOException e) {
                	e.printStackTrace();
        				
                }
                                      
                   
                // asigna toda la cadena leda
                // al control editable                                
                editText.setText(buf);
                     
                // mensaje de lectura correcta
                Toast.makeText(getBaseContext(),"Lectura correcta del archivo", Toast.LENGTH_SHORT).show();
            } 
                     	
        });
    
   
        // Un clic en el botn Guardar
        // provoca que el contenido se escribe en 
        // el archivo
        btnGuardar.setOnClickListener(new View.OnClickListener() {
        public void onClick(View v) {         
        	
        	// se obtiene la cadena de texto
        	// que se han introducido en el
        	// control EditText
        	String str = editText.getText().toString();
            try 
            {   
            	
            	// inicio de la parte diferente (2) respecto al proyecto
                // TestGuardarArchivo
            	// acceso al almacenamiento externo del dispositivo
            	File objSD = Environment.getExternalStorageDirectory();
            	File objCarpeta = new File(objSD.getAbsolutePath() +
            			"/MisDocs");
            	objCarpeta.mkdirs();
            	File objFile = new File(objCarpeta, "file01.txt");                	
                FileOutputStream objFos = new FileOutputStream(objFile);               
                // fin de la parte diferente (2) respecto al proyecto
                // TestGuardarArchivo   
                
                // se crea un objeto OutputStreamWriter
                // que nos permite escribir
                OutputStreamWriter objOsw = new  OutputStreamWriter(objFos);
                
                // escribe la cadena en el archivo
                objOsw.write(str);              
                objOsw.flush(); 
                objOsw.close();
                
                // escritura correcta
                Toast.makeText(getBaseContext(), "Escritura correcta", Toast.LENGTH_SHORT).show();
             
                // limpia el contenido del control
               editText.setText("");
             
             } 
             catch (IOException e) 
             { 
            	 // generar un mensaje de excepcin
    			 Log.e("test", "excepcin al procesar archivo en escritura", e);                     
             }  
             //==================================
        }
    });
    
}
}