package com.inforbooks.controlpersonalizado;

import android.os.Bundle;
import android.app.Activity;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.Toast;

public class MainActivity extends Activity {

	private CircleMeterView cmv;
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		
		// Se obtiene la referencia al objeto CircleMeterView
		cmv = (CircleMeterView) this.findViewById(R.id.circleMeterView);
		// Se define el rango de velocidades; desde 0 hasta...
		cmv.setRango(-40,320);
		cmv.setUnidad("Km/h");
		
		// Se informa la velocidad vigente
		// por ahora, un valor constante
		// Ms adelante usaremos los datos de un sensor 
		cmv.setMeter(160);
		

		Button btn1 = (Button) findViewById(R.id.button1);
		btn1.setOnClickListener(btnListener);
		
		Button btn2 = (Button) findViewById(R.id.button2);
		btn2.setOnClickListener(btnListener);
		
		
	}
	// Gestiona los clics de los botones
	// para cambiar la velocidad
	private OnClickListener btnListener = new OnClickListener() {
		public void onClick(View view){
			// Por ahora se incrementa la velocidad con un botn
			// Ms adelante utilizaremos un sensor de velocidad
			Button btn = (Button) view;
			float  velocidad = cmv.getMeter();
			Toast.makeText(getBaseContext(),"Botn:" + btn.getText() + ".", Toast.LENGTH_LONG).show();
			if (btn.getText().toString().equals("+"))
				velocidad = velocidad+20;
			else
				velocidad = velocidad-10;
			
		
			// Asigna la velocidad
			cmv.setMeter(velocidad);
			//Toast.makeText(getBaseContext(),"Nueva velocidad: " + String.valueOf(velocidad) , Toast.LENGTH_LONG).show();
		}
	};
	
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.activity_main, menu);
		return true;
	}

}
