/** archivo src/com.inforbooks.dialogo
 * DialogoActivity.java
 * 
 */

package com.inforbooks.dialogo;

import android.app.Activity;
import android.os.Bundle;
import android.app.AlertDialog;
import android.app.Dialog;
import android.content.DialogInterface;
import android.view.View;
import android.widget.Button;
import android.widget.Toast;


public class DialogoActivity extends Activity {
	CharSequence[] colores = {"Rojo", "Azul", "Amarillo", "Verde", "Blanco", "Negro", "Violeta", "Gris"};
	boolean[] selecciones= new boolean [colores.length];
	
    /**OnCreate, se llama cuando la actividad se crea por 
    * primera vez. */
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
        /** busca el objeto botn por el identificador
        * */
        Button btn1= (Button) findViewById(R.id.button1);
   
        
        /** define una funcin que est atendiendo el evento
        * click en el botn
        */
        btn1.setOnClickListener(new View.OnClickListener() {
        	public void onClick(View vista) {
        		showDialog(0);
        	}
        });
    }

    /* el mtodo onCreateDialog deveule un objeto de tipo
     * Dialog
     * */
@Override
protected Dialog onCreateDialog(int id) {
	/* se crea el dilogo de tipo AlertDialog
	 * (clase derivada de la clase Dialog)
	 * que puede tener 1, 2 o 3 botones */
	switch (id) {
	case 0:		
		return new AlertDialog.Builder(this)
		.setIcon(R.drawable.icon)
		.setTitle("Elija colores")
		.setPositiveButton("Aceptar", new 
			DialogInterface.OnClickListener() {
			public void onClick(DialogInterface dialog,
					int which)
			{
				Toast.makeText(getBaseContext(),
						"Aceptado", Toast.LENGTH_LONG).show();
			}
		})
		.setNegativeButton("Cancelar", new 
			DialogInterface.OnClickListener() {
			public void onClick(DialogInterface dialog,
					int which)
			{
				Toast.makeText(getBaseContext(),
						"Cancelado", Toast.LENGTH_LONG).show();
			}
		})
		.setMultiChoiceItems(colores, selecciones, new
				DialogInterface.OnMultiChoiceClickListener() {
					@Override
					public void onClick(DialogInterface dialog, int which, boolean isChecked) {
						Toast.makeText(getBaseContext(),
								colores[which] + (isChecked ? " Seleccionado!": 
								" (anulada la seleccin)"),
								Toast.LENGTH_SHORT).show();
					}
				}
	     )
		.create();
}
return null;
}
}