package com.inforbooks.emisoresreceptores;

import android.os.Bundle;
import android.app.Activity;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.view.View;
import android.widget.Toast;



	public class MainActivity extends Activity {
	    MiReceptorInterno receptorInterno;
	    IntentFilter filtroIntento;
	    
	    @Override
	    public void onCreate(Bundle savedInstanceState) {
	        super.onCreate(savedInstanceState);
	        setContentView(R.layout.activity_main);
	        
	        // En onCreate() se crean estos objetos
	        // para no tener que recrearlos
	        // en cada pausa/reinicio
	        
	        // Esta clase la registraremos por cdigo.
	        // A las otras dos clases (UnaClaseReceptora
	        // y OtraClasereceptora) las registraremos
	        // en el archivo de manifiesto (por lo que
	        // estarn atentas incluso aunque la 
	        // aplicacin no est en ejecucin.
	        // Como el mensaje ACCION_TEST01 lo emite esta
	        // misma aplicacin en este caso el
	        // registro por manifiesto tiene el mismo
	        // efecto que el registro por cdigo
	        
	        receptorInterno = new MiReceptorInterno();
	        
	        // Identificador del intento para el filtrado
	        filtroIntento = new IntentFilter("ACCION_TEST01");
	    }

	    @Override
	    public void onResume() {
	        super.onResume();
	        // al reiniciar se registra el receptor
	        // nuevamente
	        // se define una prioridad baja
	        // esto significa que recibir el mensaje
	        // despus que las otras dos clases receptoras
	        filtroIntento.setPriority(10);
	        registerReceiver(receptorInterno, filtroIntento);
	    }    
	    
	    @Override
	    public void onPause() {
	        super.onPause();
	        // en cada pausa se anula el registro 
	        // del receptor
	        unregisterReceiver(receptorInterno);
	    }    
	    
	    public void onClick(View view) {
	    	// Al hacer clic se emite el mensaje
	    	// de la accin hacia todos los
	    	// receptores
	        Intent intento = new Intent("ACCION_TEST01");
	        intento.putExtra("datos", "Datos del evento ACCION_TEST01");
	        
	        // Se toma en cuenta la prioridad
	        sendOrderedBroadcast(intento, null);
	    }

	    public class MiReceptorInterno extends BroadcastReceiver {
	        @Override
	        public void onReceive(Context context, Intent intento) {
	            Toast.makeText(context, 
	                    "onReceive de clase MiClaseInterno: " + 
	                    intento.getStringExtra("datos"),
	                    Toast.LENGTH_LONG).show();
			    // Si se aborta la emisin
        		// no se propaga ms
			    //abortBroadcast();
	        }
	    }
	    
	}