package com.inforbooks.geociencia.p01;

import java.io.DataInputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import android.app.Activity;


public class GeoCienciaAct extends Activity {
	
	// nombre del archivo de prefrencias
	public static final String PREFERENCIAS = "Preferencias";
	
	// indicador para el log
	public static final String TAG = "GeoCiencia! log: ";  
	
	// nombre de datos almacenados en preferencias
	public static final String PREFERENCIAS_NOMBRE = "NOMBRE";
	public static final String PREFERENCIAS_PSW = "PSW";  
	public static final String PREFERENCIAS_IDIOMA = "IDIOMA"; 
	
	// nombre de datos almacenados aadidos en el paso 6
	public static final String PREFERENCIAS_PUNTOS = "PUNTOS";  
	public static final String PREFERENCIAS_FALLOS = "FALLOS";  
	public static final String PREFERENCIAS_SECUENCIA = "SECUENCIA";  	 
    
	// nombre de etiquetas XML aadidos en el paso 6
	// Tags del archivo de preguntas
	public static final String TAG_PREGUNTA = "pregunta";
	public static final String TAG_PREGUNTA_SECUENCIA = "secuencia";
    public static final String TAG_PREGUNTA_TEXTO = "texto";
    public static final String TAG_PREGUNTA_IMAGEN = "imagen";
	public static final String TAG_PREGUNTA_RESPUESTA = "respuesta";
	public static final String TAG_PREGUNTA_VALOR = "valor"; 
	// cantidad de preguntas
    public static final int 	CANTIDAD_PREGUNTAS = 6;
    
  	
    // nombre de objeto aadido en el paso 7
 	public AdaptadorBD miBD;
 	
  
   // mtodos accesible desde las clases derivadas
   public String leerArchivo(String tag, int id)  throws IOException {
	   // Lectura del archivo de texto 
	   // definido como recurso raw
	   // el contenido pasa al control TextView
	   // se obtiene el objeto InputStream 
	   InputStream objIs = getResources().openRawResource(id);
		 
	   // cadena para guardar cada lnea leda
	   String sLin = null; 
	     
	   // se crea el bufer de string
	   StringBuffer objSb =  new StringBuffer();
		 
	   // objeto que permite la lectura lnea a lnea
	   DataInputStream objDis =new DataInputStream(objIs);
	   
	   // Bucle de lectura
	   // mientras haya datos.
	   
	   // readline() devuelve una cadena que contiene
	   // la siguiente lnea de texto del flujo de datos.
	   while ((sLin = objDis.readLine()) != null) {
		   // se aade la lnea leda al bufer 
		   objSb.append(sLin + "\n");
	   }
	   // cierre de los dos objetos
	   objDis.close();
	   objIs.close();
		
	   // se devuelve todo el bufer como una cadena
	   return objSb.toString();
			   
	   } 
   
   // se aade en el paso 7
   public void verificarBD(){
	   try {        	
		   String carpetaDest = "/data/data/" + getPackageName() + "/databases/geociencia";
		   File f = new File(carpetaDest);        	
		   if (!f.exists()) {        	
			   copiarBD( getBaseContext().getAssets().open("geociencia"), 
					   new FileOutputStream(carpetaDest));
		   }
	   } catch (FileNotFoundException e) {			
		   e.printStackTrace();
	   } catch (IOException e) {
		   e.printStackTrace();
	   }
	   miBD = new AdaptadorBD(this);
	  
   }
   
   public void copiarBD(InputStream inputStream, OutputStream outputStream) 
           throws IOException {
   	// copia de a 1024 bytes
   	byte[] buffer = new byte[1024];
   	int length;
   	while ((length = inputStream.read(buffer)) > 0) {
   		outputStream.write(buffer, 0, length);
   	}
   	inputStream.close();
   	outputStream.close();
}
   
}