package com.inforbooks.geociencia.p01;

import android.os.Bundle;
import android.view.View;
import android.view.animation.Animation;
import android.view.animation.AnimationUtils;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.TextView;
import android.content.Intent;


public class MenuAct extends GeoCienciaAct {
    // onCreate() se llama una vez: al crearse la actividad  
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.menu);
        
        // array de cadenas con los nombres de las
        // entradas del men a partir de 
        // recursos de string
        /* String[] elementos = { 
        		getResources().getString(R.string.menu_jugar),
                getResources().getString(R.string.menu_resultados),
                getResources().getString(R.string.menu_usuario),
                getResources().getString(R.string.menu_ayuda) }; */
        
        // crea un array de string a partir de un recurso de tipo array       
        String[] elementos = getResources().getStringArray(R.array.entradas);        
        
        // se crea un adaptador para asociar el array de entradas 
        ArrayAdapter<String> adaptador = new ArrayAdapter<String>(this, R.layout.menu_textview, elementos);
        
        // se crea la lista de elementos del men  
        // se obtiene primero el objeto ListView
        ListView listaMenu = (ListView) findViewById(R.id.ListView_Menu);
        
        // se selecciona por defecto el 2do elemento
        listaMenu.setSelection(1);
 
        // se asigna el adaptador al objeto ListView
        listaMenu.setAdapter(adaptador);
        
        // se atienden los eventos click que puedan 
        // suceder dentro del objeto ListView
        listaMenu.setOnItemClickListener(new AdapterView.OnItemClickListener() {

        	// si hay un clic en un elemento se analiza
        	// qu elemento recibi el clic 
        	// mediante la comparacin del texto de 
        	// cada entrada respecto al que recibi el clic
            public void onItemClick(AdapterView<?> parent, 
            		View itemClicked, 
            		int position, long id) {

            	// se obtiene el objeto TextView que
            	// recibe el clic
                TextView objClicked = (TextView) itemClicked;
                
                // se obtiene la cadena de texto de ese elemento
                String strTexto = objClicked.getText().toString();

                if (strTexto.equalsIgnoreCase(getResources().getString(R.string.menu_jugar))) {
                    // Inicia la actividad del juego
                    startActivity(new Intent("com.inforbooks.geociencia.p01.JUGARACT"));
                } else if (strTexto.equalsIgnoreCase(getResources().getString(R.string.menu_resultados))) {
                    // Inicia la actividad de resultados
                    startActivity(new Intent(MenuAct.this, ResultadosAct.class));
                } else if (strTexto.equalsIgnoreCase(getResources().getString(R.string.menu_usuario))) {
                    // inicia la actividad de configuracin del usuario
                    startActivity(new Intent(MenuAct.this, UsuarioAct.class));
                } else if (strTexto.equalsIgnoreCase(getResources().getString(R.string.menu_ayuda))) {
                    // Inicia la actividad de la ayuda
                    startActivity(new Intent(MenuAct.this, AyudaAct.class));           
                }
            }
        });
        
        comenzarAnimacion();
    }
    
private void comenzarAnimacion() {
    	
    	///////////////////////////////////
    	// animacin del ttulo
        // el ttulo se anima con un cambio
    	// de opacidad del objeto TextView
    	//////////////////////////////////
    	// se crea un objeto TextView a partir
    	// del objeto TextView del layout 
    	TextView txtTitulo = (TextView) findViewById(R.id.TextViewNombrePantalla);
    	
    	// se crea un objeto Animation a partir del objeto recurso
    	// anim03    	
        Animation objAnim01 = AnimationUtils.loadAnimation(this, R.anim.anim03);
        
        // se inicia la animacin
        txtTitulo.startAnimation(objAnim01); 
}
}