package com.inforbooks.geociencia.p01;

import android.content.Context;
import android.os.Bundle;
import android.widget.TabHost;
import android.widget.TabHost.TabSpec;
import android.widget.TableLayout;
import android.widget.TableRow;
import android.widget.TextView;
import android.content.SharedPreferences;
import android.database.Cursor;


public class ResultadosAct extends GeoCienciaAct {
  	
	SharedPreferences oDatosUsuario;
	String strJugador;
	boolean bPrimero = true;
	
	
	// variables para la gestin de la base de datos
	private AdaptadorBD miBD;

	// cursor de uso general
	private Cursor cur; 


	public void onCreate(Bundle savedInstanceState) {
		/** invocado en la primera creacin. */
        super.onCreate(savedInstanceState);
        setContentView(R.layout.resultados);
        
        // Se recuperan los datos de usuario desde 
        // SharedPreferences
        oDatosUsuario = getSharedPreferences(PREFERENCIAS, Context.MODE_PRIVATE);
     	        
	    // se accede al nombre del jugador para colocarlo en la interfaz	     	        
     	strJugador = oDatosUsuario.getString(PREFERENCIAS_NOMBRE, "s/n");	
        
     	// se configura el control TabHost
     	TabHost objTH = (TabHost) findViewById(R.id.tabhost);
        objTH.setup();
        
        // ficha 1
        TabSpec objTS1 = objTH.newTabSpec("Todos");
        objTS1.setIndicator(getResources().getString(R.string.resultados_tab1),getResources().getDrawable(android.R.drawable.arrow_down_float));
        
        objTS1.setContent(R.id.scrollView1);
        objTH.addTab(objTS1);
        
        // ficha 2
        TabSpec objTS2 = objTH.newTabSpec("Mi record");
        objTS2.setIndicator(getResources().getString(R.string.resultados_tab2),getResources().getDrawable(android.R.drawable.arrow_down_float));
        
        objTS2.setContent(R.id.scrollView2);
        objTH.addTab(objTS2);
        
        // se define la ficha vigente        
        objTH.setCurrentTabByTag("Todos");
        
        // se buscan los objetos TableLayout 
        // y se le asignan los encabezados
        TableLayout tblTodos = (TableLayout) findViewById(R.id.TableLayout1);
        TableLayout tblMiRecord = (TableLayout) findViewById(R.id.TableLayout2);
        insertarEncabezado(tblTodos);
        insertarEncabezado(tblMiRecord);
        
        verificarBD();
              
        // crea el objeto base de datos
        miBD = new AdaptadorBD(this); 
        
        // obtener la lista de records
   		miBD.open();
   		cur = miBD.leerTodos();
   		if (cur.moveToFirst()) {
   			int contador = 1;
   			do {
   				String   resultadoStrJugador = cur.getString(1);
				String   resultadoStrPuntos = cur.getString(2);
				String   resultadoStrOrden = String.valueOf(contador);
				contador = contador + 1;
				insertarFila(tblTodos, resultadoStrJugador, resultadoStrPuntos, resultadoStrOrden);
   				} while (cur.moveToNext());
   			    cur.close();
   		}
   		cur = miBD.leerPorNombre(strJugador);
   		if (cur.moveToFirst()) {
   			int contador = 1;
   			do {
   				String   resultadoStrJugador = cur.getString(1);
				String   resultadoStrPuntos = cur.getString(2);
				String   resultadoStrOrden = String.valueOf(contador);
				contador = contador + 1;
				insertarFila(tblMiRecord, resultadoStrJugador, resultadoStrPuntos, resultadoStrOrden);
   				} while (cur.moveToNext());
   		}
   		
    	miBD.close(); 
	}	
	
	private void insertarFila(final TableLayout tblResultado, 
				String strNombre, String strPuntos, String strOrden) {
		    // se inserta una fila en TableLayout
            final TableRow tblFila = new TableRow(this);
            
            int txtColor = getResources().getColor(R.color.resultados_textcolor_filatabla);
            float txtSize;
            // la primera fila tiene un tamao mayor
            // porque es el ganador
            if (bPrimero) { txtSize = getResources().getDimension(R.dimen.resultados_fila1tabla_textsize);}
            else {txtSize = getResources().getDimension(R.dimen.resultados_filatabla_textsize);}
            bPrimero = false;
            
            // los datos de la fila se reciben en los parmetros de
            // invocacin
            addTextoCelda(tblFila, strOrden, txtColor, txtSize);
            addTextoCelda(tblFila, strNombre, txtColor, txtSize);
            addTextoCelda(tblFila, strPuntos, txtColor, txtSize);
               
            tblResultado.addView(tblFila);
	}   
	
	private void insertarEncabezado(TableLayout tbl) {
        // lnea de encabezado
        TableRow titTabla = new TableRow(this);
        int txtColor = getResources().getColor(R.color.resultados_textcolor_headertabla);
        float txtSize = getResources().getDimension(R.dimen.resultados_headertabla_textsize);
        // coloca los ttulos de la tabla de records
        addTextoCelda(titTabla, getResources().getString(R.string.resultados_orden), txtColor, txtSize);
        addTextoCelda(titTabla, getResources().getString(R.string.resultados_nombre), txtColor, txtSize);
        addTextoCelda(titTabla, getResources().getString(R.string.resultados_puntos), txtColor, txtSize);       
        tbl.addView(titTabla);
    }
	
    private void addTextoCelda(final TableRow filaTbl, 
    	String txt, int txtColor, float txtSize) {
        // funcin auxiliar para colocar los datos en el objeto TextView
    	// de cada fila
    	TextView objTV = new TextView(this);
        objTV.setTextSize(txtSize);
        objTV.setTextColor(txtColor);
        objTV.setText(txt);
        filaTbl.addView(objTV);
    }

}