package com.inforbooks.geociencia.p01;

import android.os.Bundle;
import android.util.Log;
import android.view.animation.Animation;
import android.view.animation.AnimationUtils;

import android.content.Intent;
import android.content.pm.PackageInfo;
import android.content.pm.PackageManager;
import android.content.pm.PackageManager.NameNotFoundException;
import android.view.animation.Animation.AnimationListener;
import android.view.animation.LayoutAnimationController;
import android.widget.TableLayout;
import android.widget.TableRow;
import android.widget.TextView;
import android.view.*;



public class SplashAct extends GeoCienciaAct {
    /** Called when the activity is first created. */
	@Override 
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.splash);
        
        PackageManager objPM = getPackageManager();
        try {
        	PackageInfo objPI = objPM.getPackageInfo("com.inforbooks.geociencia.p01", 0);
           	// se obtiene el objeto TextView de la
        	// interfaz de la actividad
        	TextView txtVersion = (TextView) findViewById(R.id.TextViewVersion);
        	
        	// se asigna el texto al control
        	// TextView
        	txtVersion.setText("Versin" + Integer.toString(objPI.versionCode) +
        				"\nInforbooks  2012 \nReservados todos los derechos");
        	
        } catch (NameNotFoundException e ) {
        	Log.e(TAG, "No se pudo acceder a versionCode", e);
       	}       		
               
        // llama a una funcin auxiliar
        // para iniciar la animacin
        comenzarAnimacion();
       
      
}
	
    
    private void comenzarAnimacion() {
    	
    	///////////////////////////////////
    	// animacin del ttulo
        // el ttulo se anima con un cambio
    	// de opacidad del objeto TextView
    	//////////////////////////////////
    	// se crea un objeto TextView a partir
    	// del objeto TextView del layout 
    	TextView txtTitulo = (TextView) findViewById(R.id.TextViewNombreApp);
    	
    	// se crea un objeto Animation a partir del objeto recurso
    	// anim01    	
        Animation objAnim01 = AnimationUtils.loadAnimation(this, R.anim.anim01);
        
        // se inicia la animacin
        txtTitulo.startAnimation(objAnim01); 
        
        /////////////////////////////////////
        // Animacin de las imgenes del logo
        ////////////////////////////////////
        // carga las animaciones para todas las imgenes
        // del layout TableLayout
        Animation objAnim02 = AnimationUtils.loadAnimation(this, R.anim.anim02);
        
        // se crea el objeto LayoutAnimationController
        LayoutAnimationController controller = new LayoutAnimationController(objAnim02);
        
        // se crea un objeto TableLayout a partir
    	// del objeto del layout 
        TableLayout tabla = (TableLayout) findViewById(R.id.tableLayout1);
        
        // se accede a todos los hijos del objeto
        for (int i = 0; i < tabla.getChildCount(); i++) {
            TableRow fila = (TableRow) tabla.getChildAt(i);
            
            // asigna la animacin a la fila
            fila.setLayoutAnimation(controller);
        }
        
        // Gestin de la transicin de una actividad a otra
        // se producir cuando finalice la animacin de
        // las imgenes por el valor de duration
        
        // se asigna un listener a la animacin
        objAnim02.setAnimationListener(new AnimationListener() {
        	
        	// cuando finaliza la animacin de ejecuta
        	// este cdigo
            public void onAnimationEnd(Animation animation) {
               // se inicia una actividad nueva
               startActivity(new Intent(SplashAct.this, MenuAct.class));
               // finaliza la actividad vigente
               SplashAct.this.finish();
            }
            // estos mtodos estn vacos 
            // pero al ser abstractos en la clase, hay
            // que implementarlos (aunque sin cdigo)
            public void onAnimationRepeat(Animation animation) {
            }

            public void onAnimationStart(Animation animation) {
            }
        });
        
             
    }
    
    public boolean onKeyDown(int keyCode, KeyEvent evento) {
    	// el objeto Intent nos permite
    	// activar una nueva actividad
    	 startActivity(new Intent(SplashAct.this, MenuAct.class));
         SplashAct.this.finish();
    	 return true;    	
    }
    
    
    
    @Override
    protected void onPause() {
        super.onPause();
        // Se suspende la animacin del ttulo
        TextView objAnim01 = (TextView) findViewById(R.id.TextViewNombreApp);
        objAnim01.clearAnimation();
        
        // se suspende la animacin de las imgenes del logo
        TableLayout tabla = (TableLayout) findViewById(R.id.tableLayout1);
        for (int i = 0; i < tabla.getChildCount(); i++) {
            TableRow fila = (TableRow) tabla.getChildAt(i);
            fila.clearAnimation();
        }
       
    }

    @Override
    protected void onResume() {
        super.onResume();

        // Se reinicia la animacin               
        comenzarAnimacion();
    }
    
}