package com.inforbooks.googlemaps;

import java.util.List;

import com.google.android.maps.GeoPoint;
import com.google.android.maps.MapActivity;
import com.google.android.maps.MapController;
import com.google.android.maps.MapView;

import com.google.android.maps.Overlay;
import com.google.android.maps.OverlayItem;


import android.graphics.drawable.Drawable;
import android.os.Bundle;
import android.view.Menu;
import android.widget.EditText;

public class MainActivity extends MapActivity {

	MapView oMapView;
	MapController mControl;
    GeoPoint GeoP;  
 
 
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
	 	oMapView = (MapView) findViewById(R.id.mapView);
	 	oMapView.setBuiltInZoomControls(true);
	 	
	    // Obtiene el objeto MapController
	    mControl = oMapView.getController();
	    
	    // Por defecto posicionamos un
 		// sitio geogrfico para mostrar
 		// el primer mapa
         double lat = 42.17;
         double longi = 3.12;

         GeoP= new GeoPoint ((int) (lat * 1E6), (int)(longi * 1E6));  
	        
	    // Vector de overlays
	    List<Overlay> listaOverlays = oMapView.getOverlays();
	    
	    // Se obtiene el objeto grfico que se mostrar
	    // en el mapa
	    Drawable objGrafico = 
	            this.getResources().getDrawable(R.drawable.objgrafico);
	        
	    MiOverlay itemOverlay = 
	            new MiOverlay(objGrafico, this);
	    
	    // Anotacin asociada a un punto geogrfico
	    OverlayItem itemOverlay1 = new OverlayItem(
	            GeoP, "Nota 1", "Desde aqu vamos hacia Francia!");

	    // Se aade el tem de overlay
	    itemOverlay.addOverlay(itemOverlay1);

	    // Se aade el itemOverlay al vector
	    listaOverlays.add(itemOverlay);

	    // Navegar al punto  
	    mControl.animateTo(GeoP);  
	    
	    // Se determina un nivel de zoom
	    mControl.setZoom(12);
	    
	    lat = 42.151*1E6;
	    longi = 3.16*1E6;
	    
	    GeoPoint Geop2 = new GeoPoint ((int) (lat), (int)(longi)); 
	    
	    MapView.LayoutParams geoLP;
	    geoLP = new MapView.LayoutParams(MapView.LayoutParams.WRAP_CONTENT, 
	    				MapView.LayoutParams.WRAP_CONTENT,
	    				Geop2,
	    				MapView.LayoutParams.TOP_LEFT);
	    
	    EditText et1= new EditText(getApplicationContext());
	    et1.setText("Un texto...");
	    oMapView.addView(et1,geoLP);
	    
	    geoLP = new MapView.LayoutParams(MapView.LayoutParams.WRAP_CONTENT, 
				MapView.LayoutParams.WRAP_CONTENT,
				20,20,
				MapView.LayoutParams.TOP_LEFT);
	    
	    EditText et2= new EditText(getApplicationContext());
	    et2.setText("La Tierra");
	    oMapView.addView(et2,geoLP);
	    
	    
	    
	    
	 }

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}

	@Override
	protected boolean isRouteDisplayed() {
		// TODO Auto-generated method stub
		return false;
	}

}
