package com.inforbooks.googlemaps;

import java.util.ArrayList;

import android.app.AlertDialog;
import android.content.Context;
import android.graphics.drawable.Drawable;

import com.google.android.maps.ItemizedOverlay;
import com.google.android.maps.OverlayItem;

public class MiOverlay extends ItemizedOverlay<OverlayItem> {

	// Vector de objetos OverlayItem  
    private ArrayList<OverlayItem> overlays = new ArrayList<OverlayItem>();
    Context contexto;
    
    public MiOverlay(Drawable defaultMarker) {
        super(boundCenterBottom(defaultMarker));
    }

    public MiOverlay(Drawable defaultMarker, Context context) {
        super(boundCenterBottom(defaultMarker));
        contexto = context;
    }

	 // se aade un overlay al mapa
    public void addOverlay(OverlayItem overlay) {
        overlays.add(overlay);
        // Dibuja los objetos OverlayItem
        populate();
    }
    
    // se elimina un overlay del mapa
    public void removeOverlay(OverlayItem overlay) {        
        overlays.remove(overlay);
        // Dibuja los objetos OverlayItem 
        populate();
    }
    
    // Devuelve los objetos OverlayItem en 
    // el vector
    @Override
    protected OverlayItem createItem(int i) {
        return overlays.get(i);
    }

    // Devuelve la cantidad de overlays
    @Override
    public int size() {
    	// Cantidad de elementos
        return overlays.size();
    }
    
    // Se ejecuta cuando el usuario toca el objeto
    // del elemento del overlay  
    @Override
    protected boolean onTap(int index) {
    	// Obtiene el elemento
        OverlayItem elemento = overlays.get(index);
        
        // Se genera un cuadro de dilogo  
        AlertDialog.Builder cuadroDiag = new AlertDialog.Builder(contexto);
        
        // Ttulo del cuadro
        cuadroDiag.setTitle(elemento.getTitle());
        // Detalle de la anotacin
        cuadroDiag.setMessage(elemento.getSnippet());
        
        // Muestra el cuadro
        cuadroDiag.show();
        return true;
    }
}