package com.inforbooks.intentdatos;

import android.app.Activity;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.view.View;
import android.widget.Toast;

public class OtraActividad extends Activity {
	 @Override
	    public void onCreate(Bundle savedInstanceState) {
	        super.onCreate(savedInstanceState);
	        setContentView(R.layout.otra_actividad);
	        
	        // Obtiene datos pasado usando getStringExtra() 
	        Toast.makeText(this,
	        		"Dato recibido" +
	    	        "\nValor string: " +	
	        		getIntent().getStringExtra("1String"), 
	        		Toast.LENGTH_SHORT).show();

	        // Obtiene datos pasado usando getIntExtra() 
	        Toast.makeText(this,
	        		"Dato recibido" +
	    	        "\nValor float: " +	
	        		Float.toString(
	        		getIntent().getFloatExtra("2Float", 0)), 
	        		Toast.LENGTH_SHORT).show();        
	        
	        
	        // Obtiene el objeto Bundle  
	        Bundle bundle = getIntent().getExtras();

	        // Obtiene datos empaquetados dentro
	        // del objeto Bundle usando getString()       
	        Toast.makeText(this,
	        		"Dato recibido" +
	    	        "\nValor string: " +	
	        		bundle.getString("5String"), 
	        		Toast.LENGTH_SHORT).show();

	        // Obtiene datos empaquetados dentro
	        // del objeto Bundle usando getDouble()     
	        Toast.makeText(this,
	        		"Dato recibido" +
	        		"\nValor double: " +		
	        		Double.toString(bundle.getDouble("7Double")), 
	        		Toast.LENGTH_SHORT).show();
	        
	        // Obtiene el objeto aadido en la invocacin
	        // con PutExtra()
	        UnaClaseAuxiliar obj = (UnaClaseAuxiliar) getIntent().getSerializableExtra("ObjetoUnaClaseAuxiliar");
	        
	        Toast.makeText(this, 
	        		"Objeto recibido:" +
	        		"\nID: "  + String.valueOf(obj.getID()) +
	        		"\nNombre: " + obj.getNombre() +
	        		"\nPas: " + obj.getPais(), Toast.LENGTH_SHORT).show();
	    }
	        
	    public void onClick(View view) {
	        // Se usa el objeto Intent 
	    	// para devolver datos
	        Intent i = new Intent();            

	        // Con setData() se devuelven valores
	        i.setData(Uri.parse(
	            "http://www.inforbooks.com"));
	        
	        // Aadimos datos con putExtra()  
	        // para devover valores
	        i.putExtra("Verdadero/Falso", true);
	        i.putExtra("Nro", 5);	                          

	        // Devuelve el resultado y el objeto Intent
	        setResult(RESULT_OK, i);   
	        
	        finish();
	    }    
	    
	}


