package com.inforbooks.lectorproveedorcontenidos;


import java.text.SimpleDateFormat;
import java.util.ArrayList;

import android.app.ListFragment;
import android.os.Bundle;
import android.view.View;
import android.widget.SimpleCursorAdapter;
import android.widget.SimpleCursorAdapter.ViewBinder;
import android.widget.TextView;
import android.app.LoaderManager;

import android.content.CursorLoader;
import android.content.Intent;
import android.content.Loader;
import android.database.Cursor;


public class NewsListFragment extends ListFragment implements LoaderManager.LoaderCallbacks<Cursor> {

	 SimpleCursorAdapter adapter;
	 ArrayList<Noticia> noticias = new ArrayList<Noticia>();	  

	  @Override
	  public void onActivityCreated(Bundle savedInstanceState) {
	    super.onActivityCreated(savedInstanceState);	    
 
	    
	    adapter = new SimpleCursorAdapter(getActivity(),
	      android.R.layout.two_line_list_item, null,
	      new String[] {LectorProveedor.COL_DATE, LectorProveedor.COL_TITLE},
	      new int[] { android.R.id.text1,android.R.id.text2}, 0);
	    
	    // La fecha viene en forma de Date (long)
	    // y hay que formatearla para mostrarla 
	    // en pantalla
	    adapter.setViewBinder(new ViewBinder() {

	        public boolean setViewValue(View aView, Cursor aCursor, int aColumnIndex) {

	            if (aColumnIndex == 1) {
	                    Long fecha = aCursor.getLong(aColumnIndex);
	                    TextView textView = (TextView) aView;
	                    SimpleDateFormat timeFormat = new SimpleDateFormat("dd-MM kk:mm");
	                    textView.setText( timeFormat.format(fecha));
	                    return true;
	             }

	             return false;
	        }});

		        
	    setListAdapter(adapter);

	    getLoaderManager().initLoader(0, null, this);  

	    // Se elimina el uso de un Thread
	    // ya que esto se har en un servicio
	    accederNoticias(); 	     
	    
	  }	  
	
	  // La mayor parte del cdigo de este mtodo
	  // se ha trasladado al mtodo del mismo nombre
	  // que est en el servicio ActualizadorService
	  public void accederNoticias() {
		  
		  // Se reinicia el cargador del cursor
		  getLoaderManager().restartLoader(0, null, NewsListFragment.this);
		  // Inicia el servicio
		  getActivity().startService(new Intent(getActivity(), 
				  	ActualizadorService.class));			      
	   
	  }

	  
	@Override
	public Loader<Cursor> onCreateLoader(int id, Bundle args) {
		// TODO Auto-generated method stub
		 String[] projection = new String[] {
				 LectorProveedor.COL_ID,
				 LectorProveedor.COL_DATE,
				 LectorProveedor.COL_TITLE,
				 LectorProveedor.COL_DESCRIPTION
			    }; 

		 LectorNoticias lectorNoticias = (LectorNoticias)getActivity();
		 long dtLimite = System.currentTimeMillis() - lectorNoticias.rangoDias;
		 	
		 // filtra slo las noticias de la cantidad de das requeridos
		 // por configuracin
		 String where = LectorProveedor.COL_DATE + " > " + dtLimite;
		 
		 // Ordenar el cursor por fecha y hora descendente
		 String orden = LectorProveedor.COL_DATE + " DESC";
			   
		 CursorLoader loader = new CursorLoader(getActivity(), 
			    		LectorProveedor.CONTENT_URI, projection, where, null, orden);
			    
		return loader;
	}

	@Override
	public void onLoadFinished(Loader<Cursor> arg0, Cursor arg1) {
		// TODO Auto-generated method stub
		 adapter.swapCursor(arg1);
	}

	@Override
	public void onLoaderReset(Loader<Cursor> arg0) {
		// TODO Auto-generated method stub
		 adapter.swapCursor(null);
	}
	 

	}
