package com.inforbooks.lectorxmlsettings;


import android.os.Bundle;
import android.preference.PreferenceManager;
import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.res.Resources;
import android.view.Menu;
import android.view.MenuItem;

public class MainActivity extends Activity {


	public boolean actualizaAutomatica = false;
	public int minutosFrecuencia = 0;
	
	private static final int VER_CONFIGURACION = 1;
	static final private int MENU_CONFIGURACION = Menu.FIRST+1;
	  
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		
		  actualizarPreferencias();
	}



	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		super.onCreateOptionsMenu(menu);

	    menu.add(0, MENU_CONFIGURACION, Menu.NONE, R.string.menu_configuracion);

	    return true;
	}
	
	public boolean onOptionsItemSelected(MenuItem item){
		super.onOptionsItemSelected(item);
		switch (item.getItemId()) {
			case (MENU_CONFIGURACION): {
		        Intent i = new Intent(this, SettingsActivity.class);
		        startActivityForResult(i, VER_CONFIGURACION);
		        return true;
			}
		}
		return false;
	}
		  


	private void actualizarPreferencias() {
		// Obtiene las preferencias compartidas
		Context context = getApplicationContext();
		SharedPreferences misPreferencias = 
				PreferenceManager.getDefaultSharedPreferences(context);

		// Obtiene el ndice para conocer
		// la frecuencia de actualizacin 
		// de las noticias
		// Por defecto asume una actualizacin cada 5 minutos 
		int idxFrecuencia = misPreferencias.getInt(SettingsActivity.PREF_IDX_FRECUENCIA, 1);
		// Se valida que no lleguen valores negativos
		if (idxFrecuencia < 0)  idxFrecuencia = 1;

		// Actualizacin automtica; por defecto es false
		actualizaAutomatica = misPreferencias.getBoolean(SettingsActivity.PREF_ACT_AUTOMATICA, false);

		// Acceso a las matrices en recursos
		Resources misRsx = getResources();		    
		// Obtiene la matriz de valores de frecuencia
		String[] strFrecuencias = misRsx.getStringArray(R.array.valores_frecuencias);

		// Convierte la cadena a string
		minutosFrecuencia = Integer.valueOf(strFrecuencias[idxFrecuencia]);
	}

	@Override
	public void onActivityResult(int requestCode, int resultCode, Intent data) {
		super.onActivityResult(requestCode, resultCode, data);

		if (requestCode == VER_CONFIGURACION)
			if (resultCode == Activity.RESULT_OK) {
		        actualizarPreferencias();
		
			}
		}

}
