package com.inforbooks.phone1;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.telephony.PhoneStateListener;
import android.telephony.TelephonyManager;
import android.widget.Toast;

public class PhoneStateControl extends BroadcastReceiver{
	// Objeto TelephonyManager
	TelephonyManager oTM;
	// Clase interna que acta como Listener
	PhoneListener oPL;
	// Control
	static boolean detectandoCambios = false;
	
	
	@Override
	public void onReceive(Context context, Intent intent) {
		 
		oPL = new PhoneListener(context);
		oTM = ((TelephonyManager) context
				.getSystemService(Context.TELEPHONY_SERVICE));

		// se controla que slo
		// haya un nico Listener
		if (!detectandoCambios) {
			// Se registra para recibir los
			// cambios de estado
			oTM.listen(oPL,
					PhoneStateListener.LISTEN_CALL_STATE);
			detectandoCambios = true;
		}
	}

	public class PhoneListener extends PhoneStateListener {
		Context context;
		public PhoneListener(Context context) {
			this.context = context;
		}        

		@Override
		public void onCallStateChanged(int state, 
				String incomingNumber) {
			super.onCallStateChanged(state, incomingNumber);
			// Se reemplaza el mtodo onCallStateChanged
			
			switch (state) {
			case TelephonyManager.CALL_STATE_IDLE:
				// Aqu podramos incluir cdigo que
				// acte cuando el telfono deja de 
				// ser utilizado o deja de llamar
				// ...
				Toast.makeText(context, "Estado ocioso", 
						Toast.LENGTH_LONG).show();
				break;
			case TelephonyManager.CALL_STATE_RINGING:
				// Aqu podramos incluir cdigo que
				// acte antes de atender el telfono
				//...
				// Se muestra un cuadro de dilogo
				// que avisa el nmero que est llamando
				Toast.makeText(context, "Est llamando el nmero: " + incomingNumber,
						Toast.LENGTH_LONG).show();
				break;
			case TelephonyManager.CALL_STATE_OFFHOOK:
				// Aqu podramos incluir cdigo que
				// acte cuando el telfono
				// est transmitiendo
				//...
				// Se muestra un cuadro de dilogo
				// que avisa el cambio de estado
				Toast.makeText(context, "En comunicacin", 
						Toast.LENGTH_LONG).show();
				break;
			}
		}
	}
}

 
