package com.inforbooks.smsentrantes;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.telephony.SmsMessage;
import android.widget.Toast;

public class SMSEntrantes extends BroadcastReceiver {

    @Override
    public void onReceive(Context context, Intent intent)
    {
        // El objeto Intent
    	// contiene los datos
    	// del contenido del
    	// mensaje SMS entrante
        Bundle bundle = intent.getExtras();
        SmsMessage[] mensajes = null;
        String txt = "SMS recibido de: ";
        if (bundle != null)
        {
            // Recupera el mensaje SMS
            Object[] pdus = (Object[]) bundle.get("pdus");
            mensajes = new SmsMessage[pdus.length];
            for (int i=0; i < mensajes.length; i++){
                mensajes[i] = SmsMessage.createFromPdu((byte[])pdus[i]);
                // del primero de los mensajes
                // se recupera el emisor
                if (i==0) {
                    //Obtiene la direccin 
                	// (nmero de telfono)
                	// emisor del mensaje
                    txt += mensajes[i].getOriginatingAddress();
                    txt += "> mensaje: ";
                } 
                // recupera el cuerpo del mensaje  
                txt += mensajes[i].getMessageBody().toString();                    
            }
            // Muestra el mensaje 
            // en un Toast
            Toast.makeText(context, txt, Toast.LENGTH_SHORT).show();
            
            // Impide que el mensaje sea procesado
            // por otras aplicaciones  
            abortBroadcast();
                     
        }
    }
}

