package com.inforbooks.testserviciolocal;

import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.app.Service;
import android.content.Intent;
import android.media.MediaPlayer;
import android.os.IBinder;
import android.widget.Toast;

public class Servicio extends Service{
	MediaPlayer oPlayer;
	private NotificationManager oNM;
	private Notification oN;
	 

	@Override
	public void onCreate() {
		oPlayer = MediaPlayer.create(this, R.raw.musica);	
		
		// obtenemos un objeto para utilizar
		// un servicio global del sistema
		oNM = (NotificationManager) getSystemService(NOTIFICATION_SERVICE);
		
		// creamos la notificacin con un icono estndar
		// un texto y la indicacin que es una notificacin
		// inmediata
		oN = new Notification(R.drawable.icon, "Fondo musical en proceso", 
				System.currentTimeMillis());
		
	}
	
	@Override
	public IBinder onBind(Intent arg0) {
		 
		return null;
	}
	
	@Override
	public int onStartCommand(Intent intento, int flags, int inicioId) {
		// el servicio se ejecuta hasta que
		// sea detenido de modo explcito
		Toast.makeText(this, "Servicio iniciado", Toast.LENGTH_LONG).show();
		oPlayer.start();
		oPlayer.setLooping(true);		
		
		// se crea el intento pendiente que ser la actividad a ejecutar
		// cuando se pulse sobre la notificacin
		PendingIntent oPI = PendingIntent.getActivity(this, 0, 
				new Intent(this, TestServicioLocalActivity.class), 0 );
		// se configura el contenido de la notificacin
		oN.setLatestEventInfo(this, "ServicioLocal", "Est reproduciendo msica", oPI);
		
		// se pasa la notificacin creada al objeto
		// NotificationManager con un identificador
		oNM.notify(2, oN);		
	
		return START_STICKY;
		
	}
	@Override
	public void onDestroy() {
		super.onDestroy();
		oPlayer.stop();
		// se elimina la notificacin
		// en algunos casos nos puede interesar que quede y
		// en ese caso no incluiremos esta sentencia
		oNM.cancel(2);
	}

}
