package com.inforbooks.testserviciolocal;

import android.app.Activity;
import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.content.Intent;
import android.os.Bundle;
import android.widget.Button;
import android.view.View;

public class TestServicioLocalActivity extends Activity {
	

    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
    
    
    Button oButtonInicio = (Button) findViewById(R.id.button1);
    oButtonInicio.setOnClickListener(new View.OnClickListener() {
    	public void onClick(View v) {
    		startService(new Intent(getBaseContext(), Servicio.class));
    	}
    	
    });
    Button oButtonDetener = (Button) findViewById(R.id.button2);
    oButtonDetener.setOnClickListener(new View.OnClickListener() {
    	public void onClick(View v) {
    		stopService(new Intent(getBaseContext(), Servicio.class));
    	}
    	
    });
    Button oButtonNotificador = (Button) findViewById(R.id.button3);
    oButtonNotificador.setOnClickListener(new View.OnClickListener() {
    	public void onClick(View v) {
    		
    		// creacin de la notificacin
    		
    		// se crea el intento que se relacionar
    		// con la notificacin
    		Intent oIntent= new Intent(getBaseContext(), Notificador.class);
        	
    		// datos adicionales que acompaan al objeto Intent
        	// se coloca un identificador para poder eliminarlo despus
        	oIntent.putExtra("claveId", 1);  
        	
        	// se crea el mensaje largo que aparecer en la interfaz del notificador
        	oIntent.putExtra("texto","ste es un texto largo que aparecer dentro de la interfaz del notificador");
        	
        	// se crea el intento pendiente que ser la actividad a ejecutar
    		// cuando se pulse sobre la notificacin
        	PendingIntent oPI = PendingIntent.getActivity(getBaseContext(), 0, oIntent, 0);
        	
        	// obtenemos un objetoNotificationManager para utilizar
    		// un servicio global del sistema
        	NotificationManager oNM = (NotificationManager) getSystemService(NOTIFICATION_SERVICE);
        	
        	// creamos la notificacin con un icono estndar
    		// un texto y la indicacin que es una notificacin
    		// inmediata (es el texto que aparece en la barra de estado)
        	Notification oN = new Notification(R.drawable.icon, 
        			"Texto en barra ...", System.currentTimeMillis());
        	
        	// otros textos:
        	// estos textos son los que aparecern en el servicio de 
        	// notificaciones de Android
        	CharSequence desde = "Aplicacin TestServicioLocal";
        	CharSequence mensaje="texto para el servicio de Notificaciones";
        	
        	// configura la notificacin con la relacin
        	// a la interfaz de la clase Notificador
        	//oN.setLatestEventInfo(this, desde, mensaje, oPI);
        	oN.setLatestEventInfo(getBaseContext(), desde, mensaje, oPI);
        	
        	// define una vibracin del telfono
        	// primer parmetro: tiempo sin vibrar en ms
        	// segundo parmetro: tiempo vibrando en ms
        	// tercer parmetro: tiempo sin vibrar en ms
        	// y as sucesivamente
        	oN.vibrate = new long[] {100, 200, 100, 400};
        	
        	// asocia la notificacin con el gestor de
        	// notificaciones
        	oNM.notify(1, oN);
    	}
    	
    });
}
     
}