package com.inforbooks.notes;

import java.util.ArrayList;

import android.os.Bundle;
import android.app.Activity;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.ListView;

public class MainActivity extends Activity {

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		// se "infla" el diseo 
		setContentView(R.layout.activity_main);
		
		// Se obtienen referencias a los componentes
		// de la interfaz
		ListView miLista = (ListView) findViewById(R.id.listView1);
		// como se utilizar en una clase interior es 
		// obligatorio definir "final"
		final EditText miNota = (EditText) findViewById(R.id.editText1);
		
		// Se crea un array para contener las notas
		// como se utilizar en una clase interior es 
		// obligatorio definir "final"
		final ArrayList<String> lstNotas = new ArrayList<String>();
		
		// Se relaciona la lista con el control ListView
		// como se utilizar en una clase interior es 
		// obligatorio definir "final"
		final ArrayAdapter<String> adaptador;
		
		// Se crea el adaptador: constructor con 3 parmetros:
		// (contexto, tipo de lista simple, array)
		adaptador = new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1, lstNotas);
		
		// Se asigna el adaptador al componente ListView
		// de la interfaz
		miLista.setAdapter(adaptador);
		
		// Se crea un detector de eventos para el control
		// miNota (EditText)
		miNota.setOnKeyListener(new View.OnKeyListener() {
			
			@Override
			public boolean onKey(View v, int keyCode, KeyEvent event) {
				// TODO Auto-generated method stub
				if (event.getAction() == KeyEvent.ACTION_DOWN) {
					if ((keyCode == KeyEvent.KEYCODE_ENTER)){
						// Se aade el texto al array
						// que est vinculado a ListView
						lstNotas.add(0,miNota.getText().toString());
						adaptador.notifyDataSetChanged();
						// limpiar el rea	
						miNota.setText("");
						return true;
						
					}
				}
				return false;
			}
		});
		
		
		
		
		
		 
		
		
	};
	
	

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.activity_main, menu);
		return true;
	}

}
