package com.inforbooks.paises;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.Toast;
import android.support.v4.app.ListFragment;

public class PaisesFragmento   extends ListFragment {
    String[] lstPaises = {
            "Italia",
            "Espaa",
            "Francia",
            "Portugal",
            "Alemania",
            "Grecia",
            "Holanda"
    };

    /** Se llama al crear la actividad. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        // Relaciona lista con array
        setListAdapter(new ArrayAdapter<String>(getActivity(), 
                android.R.layout.simple_list_item_1,
                lstPaises));
    }

    // Gestin de clic en la lista
    public void onListItemClick(ListView parent, View v, int position, long id) {
        Toast.makeText(getActivity(), 
            "Pas elegido en la lista: " + lstPaises[position], 
            Toast.LENGTH_SHORT).show();
        
        String paisElegido = lstPaises[position];
        
        // Vemos si hay fragmento de detalle ya existente
        // para ver por qu camino iremos
        DetallesFragmento fragmento = (DetallesFragmento) 
            getFragmentManager().findFragmentById(R.id.detallesFragmento);
        
        // Verifica si el fragmento est en el layout actual 
        if (fragmento != null && fragmento.isInLayout()) {
            // S, ya est en pantalla
        	// usa el mtodo setpaisElegido()
        	// para mostrar el texto
            fragmento.setPaisElegido(paisElegido);
        } else {
            // invocar a la actividad del detalle
            Intent intent = new Intent(getActivity(), DetallesActivity.class);
            // se pasa el pas seleccionado como parmetro al intento
            intent.putExtra("pais", paisElegido);
            startActivity(intent);
        }
    }
}
